<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: shared_ptr.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_f6486992fdfcc735347cc2d407578037.html">FaceFilterSDK</a></li><li class="navelem"><a class="el" href="dir_80a4fd4d67846ee877317f9ddd7282cb.html">DlibWrapper</a></li><li class="navelem"><a class="el" href="dir_9b7b8713e4f43f3006d0cb3c779d469e.html">dlib</a></li><li class="navelem"><a class="el" href="dir_8046d21543c5bdd4721c6d619be3c6b2.html">smart_pointers</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">shared_ptr.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// Copyright (C) 2007  Davis E. King (davis@dlib.net)</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// License: Boost Software License   See LICENSE.txt for the full license.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#ifndef DLIB_SHARED_PTr_</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#define DLIB_SHARED_PTr_ </span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &lt;algorithm&gt;</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &lt;memory&gt;</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#include &lt;typeinfo&gt;</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span>       <span class="comment">// for the exceptions</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &quot;../algs.h&quot;</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &quot;shared_ptr_abstract.h&quot;</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160; </div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160; </div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacedlib.html">dlib</a> </div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;{</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160; </div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160; </div><div class="line"><a name="l00019"></a><span class="lineno"><a class="line" href="classdlib_1_1bad__weak__ptr.html">   19</a></span>&#160;    <span class="keyword">class </span><a class="code" href="classdlib_1_1bad__weak__ptr.html">bad_weak_ptr</a>: <span class="keyword">public</span> std::exception {};</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160; </div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160; </div><div class="line"><a name="l00023"></a><span class="lineno"><a class="line" href="classdlib_1_1weak__ptr.html">   23</a></span>&#160;    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classdlib_1_1weak__ptr.html">weak_ptr</a>;</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160; </div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160; </div><div class="line"><a name="l00027"></a><span class="lineno"><a class="line" href="structdlib_1_1shared__ptr__deleter.html">   27</a></span>&#160;    <span class="keyword">struct </span><a class="code" href="structdlib_1_1shared__ptr__deleter.html">shared_ptr_deleter</a></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;    {</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> del(<span class="keyword">const</span> <span class="keywordtype">void</span>* p) = 0;</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;        <span class="keyword">virtual</span> ~<a class="code" href="structdlib_1_1shared__ptr__deleter.html">shared_ptr_deleter</a>() {}</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160; </div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span>* get_deleter_void(<span class="keyword">const</span> std::type_info&amp; t) <span class="keyword">const</span> = 0;</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    };</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160; </div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    <span class="keyword">struct </span><a class="code" href="structdlib_1_1shared__ptr__node.html">shared_ptr_node</a>;</div><div class="line"><a name="l00043"></a><span class="lineno"><a class="line" href="structdlib_1_1weak__ptr__node.html">   43</a></span>&#160;    <span class="keyword">struct </span><a class="code" href="structdlib_1_1weak__ptr__node.html">weak_ptr_node</a></div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    {</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;        <a class="code" href="structdlib_1_1weak__ptr__node.html">weak_ptr_node</a> (</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;            <a class="code" href="structdlib_1_1shared__ptr__node.html">shared_ptr_node</a>* sn</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;        ) : </div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;            ref_count(1),</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;            shared_node(sn)</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;        {</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;            DLIB_ASSERT(sn != 0,<span class="stringliteral">&quot;&quot;</span>);</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;        }</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160; </div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;        <span class="keywordtype">long</span> ref_count;</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;        <a class="code" href="structdlib_1_1shared__ptr__node.html">shared_ptr_node</a>* shared_node;</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    };</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160; </div><div class="line"><a name="l00058"></a><span class="lineno"><a class="line" href="structdlib_1_1shared__ptr__node.html">   58</a></span>&#160;    <span class="keyword">struct </span><a class="code" href="structdlib_1_1shared__ptr__node.html">shared_ptr_node</a></div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    {</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;        <a class="code" href="structdlib_1_1shared__ptr__node.html">shared_ptr_node</a>(</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;        ) : </div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;            ref_count(1),</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;            del(0),</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;            weak_node(0)</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;        {}</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160; </div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;        <span class="keywordtype">long</span> ref_count;</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;        <a class="code" href="structdlib_1_1shared__ptr__deleter.html">shared_ptr_deleter</a>* del;</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;        <a class="code" href="structdlib_1_1weak__ptr__node.html">weak_ptr_node</a>* weak_node;</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;    };</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160; </div><div class="line"><a name="l00072"></a><span class="lineno"><a class="line" href="structdlib_1_1shared__ptr__static__cast.html">   72</a></span>&#160;    <span class="keyword">struct </span><a class="code" href="structdlib_1_1shared__ptr__static__cast.html">shared_ptr_static_cast</a> {};</div><div class="line"><a name="l00073"></a><span class="lineno"><a class="line" href="structdlib_1_1shared__ptr__const__cast.html">   73</a></span>&#160;    <span class="keyword">struct </span><a class="code" href="structdlib_1_1shared__ptr__const__cast.html">shared_ptr_const_cast</a> {};</div><div class="line"><a name="l00074"></a><span class="lineno"><a class="line" href="structdlib_1_1shared__ptr__dynamic__cast.html">   74</a></span>&#160;    <span class="keyword">struct </span><a class="code" href="structdlib_1_1shared__ptr__dynamic__cast.html">shared_ptr_dynamic_cast</a> {};</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160; </div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160; </div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt; </div><div class="line"><a name="l00079"></a><span class="lineno"><a class="line" href="classdlib_1_1shared__ptr.html">   79</a></span>&#160;    <span class="keyword">class </span><a class="code" href="classdlib_1_1shared__ptr.html">shared_ptr</a> </div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;    {</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> D&gt;</div><div class="line"><a name="l00104"></a><span class="lineno"><a class="line" href="structdlib_1_1shared__ptr_1_1deleter__template.html">  104</a></span>&#160;        <span class="keyword">struct </span><a class="code" href="structdlib_1_1shared__ptr_1_1deleter__template.html">deleter_template</a> : <span class="keyword">public</span> <a class="code" href="structdlib_1_1shared__ptr__deleter.html">shared_ptr_deleter</a></div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;        {</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;            <a class="code" href="structdlib_1_1shared__ptr_1_1deleter__template.html">deleter_template</a>(<span class="keyword">const</span> D&amp; d_) : d(d_) {}</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;            <span class="keywordtype">void</span> del(<span class="keyword">const</span> <span class="keywordtype">void</span>* p) { d((T*)p); }</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;            D d;</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160; </div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;            <span class="keywordtype">void</span>* get_deleter_void(<span class="keyword">const</span> std::type_info&amp; t)<span class="keyword"> const </span></div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;<span class="keyword">            </span>{</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;                <span class="keywordflow">if</span> (<span class="keyword">typeid</span>(D) == t)</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;                    <span class="keywordflow">return</span> (<span class="keywordtype">void</span>*)&amp;d;</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;                <span class="keywordflow">else</span></div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;                    <span class="keywordflow">return</span> 0;</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;            }</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;        };</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160; </div><div class="line"><a name="l00119"></a><span class="lineno"><a class="line" href="structdlib_1_1shared__ptr_1_1default__deleter.html">  119</a></span>&#160;        <span class="keyword">struct </span><a class="code" href="structdlib_1_1shared__ptr_1_1default__deleter.html">default_deleter</a> : <span class="keyword">public</span> <a class="code" href="structdlib_1_1shared__ptr__deleter.html">shared_ptr_deleter</a></div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;        {</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;            <span class="keywordtype">void</span> del(<span class="keyword">const</span> <span class="keywordtype">void</span>* p) { <span class="keyword">delete</span> ((T*)p); }</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160; </div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;            <span class="keywordtype">void</span>* get_deleter_void(<span class="keyword">const</span> std::type_info&amp;)<span class="keyword"> const </span></div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;<span class="keyword">            </span>{</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;                <span class="keywordflow">return</span> 0;</div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;            }</div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;        };</div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160; </div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160; </div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;        <span class="keyword">typedef</span> T element_type;</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160; </div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;        <a class="code" href="classdlib_1_1shared__ptr.html">shared_ptr</a>(</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;        ) : data(0), shared_node(0) {} </div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160; </div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;        <span class="keyword">template</span>&lt;<span class="keyword">typename</span> Y&gt; </div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;        <span class="keyword">explicit</span> <a class="code" href="classdlib_1_1shared__ptr.html">shared_ptr</a>(</div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;            Y* p</div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;        ) : data(p)</div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;        {</div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;            DLIB_ASSERT(p != 0,</div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;                <span class="stringliteral">&quot;\tshared_ptr::shared_ptr(p)&quot;</span></div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\tp can&#39;t be null&quot;</span></div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\tthis: &quot;</span> &lt;&lt; <span class="keyword">this</span></div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;                );</div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;            <span class="keywordflow">try</span></div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;            {</div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;                shared_node = <span class="keyword">new</span> <a class="code" href="structdlib_1_1shared__ptr__node.html">shared_ptr_node</a>;</div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;                shared_node-&gt;del = <span class="keyword">new</span> <a class="code" href="structdlib_1_1default__deleter.html">default_deleter</a>;</div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;            }</div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;            <span class="keywordflow">catch</span> (...)</div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;            {</div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;                <span class="keyword">delete</span> p;</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;                <span class="keywordflow">throw</span>;</div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;            }</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;        }</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160; </div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;        <span class="keyword">template</span>&lt;<span class="keyword">typename</span> Y, <span class="keyword">typename</span> D&gt; </div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;        shared_ptr(</div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;            Y* p, </div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;            <span class="keyword">const</span> D&amp; d</div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;        ) : </div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;            data(p)</div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;        {</div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;            DLIB_ASSERT(p != 0,</div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;                <span class="stringliteral">&quot;\tshared_ptr::shared_ptr(p,d)&quot;</span></div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\tp can&#39;t be null&quot;</span></div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\tthis: &quot;</span> &lt;&lt; <span class="keyword">this</span></div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;                );</div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;            <span class="keywordflow">try</span></div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;            {</div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;                shared_node = 0;</div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;                shared_node = <span class="keyword">new</span> shared_ptr_node;</div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;                shared_node-&gt;del = <span class="keyword">new</span> deleter_template&lt;D&gt;(d);</div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;            }</div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;            <span class="keywordflow">catch</span> (...)</div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;            {</div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;                <span class="keywordflow">if</span> (shared_node) <span class="keyword">delete</span> shared_node;</div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;                d(p);</div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;                <span class="keywordflow">throw</span>;</div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;            }</div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;        }</div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160; </div><div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;        ~shared_ptr() </div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;        { </div><div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;            <span class="keywordflow">if</span> ( shared_node != 0)</div><div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;            {</div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;                <span class="keywordflow">if</span> (shared_node-&gt;ref_count == 1)</div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;                {</div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;                    <span class="comment">// delete the data in the appropriate way</span></div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;                    shared_node-&gt;del-&gt;del(data);</div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;                    <span class="keyword">delete</span> shared_node-&gt;del;</div><div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160; </div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;                    <span class="comment">// notify any weak_ptrs that the data has now expired</span></div><div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;                    <span class="keywordflow">if</span> (shared_node-&gt;weak_node)</div><div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;                        shared_node-&gt;weak_node-&gt;shared_node = 0;</div><div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160; </div><div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;                    <span class="comment">// finally delete the shared_node</span></div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;                    <span class="keyword">delete</span> shared_node;</div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;                }</div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;                <span class="keywordflow">else</span> </div><div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;                {</div><div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;                    shared_node-&gt;ref_count -= 1;</div><div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;                }</div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;            }</div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;        }</div><div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160; </div><div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;        shared_ptr( </div><div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;            <span class="keyword">const</span> shared_ptr&amp; r</div><div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;        ) </div><div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;        { </div><div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;            data = r.data;</div><div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;            shared_node = r.shared_node;</div><div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;            <span class="keywordflow">if</span> (shared_node)</div><div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;                shared_node-&gt;ref_count += 1;</div><div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;        }</div><div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160; </div><div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;        <span class="keyword">template</span>&lt;<span class="keyword">typename</span> Y&gt; </div><div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;        shared_ptr(</div><div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;            <span class="keyword">const</span> shared_ptr&lt;Y&gt;&amp; r,</div><div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;            <span class="keyword">const</span> shared_ptr_static_cast&amp;</div><div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;        )</div><div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;        {</div><div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;            data = static_cast&lt;T*&gt;(r.data);</div><div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;            <span class="keywordflow">if</span> (data != 0)</div><div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;            {</div><div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;                shared_node = r.shared_node;</div><div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;                shared_node-&gt;ref_count += 1;</div><div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;            }</div><div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;            <span class="keywordflow">else</span></div><div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;            {</div><div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;                shared_node = 0;</div><div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;            }</div><div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;        }</div><div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160; </div><div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;        <span class="keyword">template</span>&lt;<span class="keyword">typename</span> Y&gt; </div><div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;        shared_ptr(</div><div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;            <span class="keyword">const</span> shared_ptr&lt;Y&gt;&amp; r,</div><div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;            <span class="keyword">const</span> shared_ptr_const_cast&amp;</div><div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;        )</div><div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;        {</div><div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;            data = const_cast&lt;T*&gt;(r.data);</div><div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;            <span class="keywordflow">if</span> (data != 0)</div><div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;            {</div><div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;                shared_node = r.shared_node;</div><div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;                shared_node-&gt;ref_count += 1;</div><div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;            }</div><div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;            <span class="keywordflow">else</span></div><div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;            {</div><div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;                shared_node = 0;</div><div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;            }</div><div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;        }</div><div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160; </div><div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;        <span class="keyword">template</span>&lt;<span class="keyword">typename</span> Y&gt; </div><div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;        shared_ptr(</div><div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;            <span class="keyword">const</span> shared_ptr&lt;Y&gt;&amp; r,</div><div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;            <span class="keyword">const</span> shared_ptr_dynamic_cast&amp;</div><div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;        )</div><div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;        {</div><div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;            data = dynamic_cast&lt;T*&gt;(r.data);</div><div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;            <span class="keywordflow">if</span> (data != 0)</div><div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;            {</div><div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;                shared_node = r.shared_node;</div><div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;                shared_node-&gt;ref_count += 1;</div><div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;            }</div><div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;            <span class="keywordflow">else</span></div><div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;            {</div><div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;                shared_node = 0;</div><div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;            }</div><div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;        }</div><div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160; </div><div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;        <span class="keyword">template</span>&lt;<span class="keyword">typename</span> Y&gt; </div><div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;        shared_ptr(</div><div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;            <span class="keyword">const</span> shared_ptr&lt;Y&gt;&amp; r</div><div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;        )</div><div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;        {</div><div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;            data = r.data;</div><div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;            shared_node = r.shared_node;</div><div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;            <span class="keywordflow">if</span> (shared_node)</div><div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;                shared_node-&gt;ref_count += 1;</div><div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;        }</div><div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160; </div><div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160; </div><div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;        <span class="keyword">template</span>&lt;<span class="keyword">typename</span> Y&gt; </div><div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;        <span class="keyword">explicit</span> shared_ptr(</div><div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;            <span class="keyword">const</span> weak_ptr&lt;Y&gt;&amp; r</div><div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;        )</div><div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;        {</div><div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;            <span class="keywordflow">if</span> (r.expired()) </div><div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160;                <span class="keywordflow">throw</span> bad_weak_ptr();</div><div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160; </div><div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;            data = r.data;</div><div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;            shared_node = r.weak_node-&gt;shared_node;</div><div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;            shared_node-&gt;ref_count += 1;</div><div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;        }</div><div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160; </div><div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;        <span class="keyword">template</span>&lt;<span class="keyword">typename</span> Y&gt;</div><div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;        <span class="keyword">explicit</span> shared_ptr(</div><div class="line"><a name="l00299"></a><span class="lineno">  299</span>&#160;            std::auto_ptr&lt;Y&gt;&amp; r</div><div class="line"><a name="l00300"></a><span class="lineno">  300</span>&#160;        )</div><div class="line"><a name="l00301"></a><span class="lineno">  301</span>&#160;        {</div><div class="line"><a name="l00302"></a><span class="lineno">  302</span>&#160;            DLIB_ASSERT(r.get() != 0,</div><div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160;                <span class="stringliteral">&quot;\tshared_ptr::shared_ptr(auto_ptr r)&quot;</span></div><div class="line"><a name="l00304"></a><span class="lineno">  304</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\tr.get() can&#39;t be null&quot;</span></div><div class="line"><a name="l00305"></a><span class="lineno">  305</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\tthis: &quot;</span> &lt;&lt; this</div><div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;                );</div><div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160;            shared_node = <span class="keyword">new</span> shared_ptr_node;</div><div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;            shared_node-&gt;del = <span class="keyword">new</span> default_deleter;</div><div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;            data = r.release();</div><div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;        }</div><div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160; </div><div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160;        shared_ptr&amp; operator= (</div><div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160;            <span class="keyword">const</span> shared_ptr&amp; r</div><div class="line"><a name="l00314"></a><span class="lineno">  314</span>&#160;        )</div><div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;        {</div><div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160;            shared_ptr(r).swap(*<span class="keyword">this</span>);</div><div class="line"><a name="l00317"></a><span class="lineno">  317</span>&#160;            <span class="keywordflow">return</span> *<span class="keyword">this</span>;</div><div class="line"><a name="l00318"></a><span class="lineno">  318</span>&#160;        }</div><div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160; </div><div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;        <span class="keyword">template</span>&lt;<span class="keyword">typename</span> Y&gt; </div><div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;        shared_ptr&amp; operator= (</div><div class="line"><a name="l00322"></a><span class="lineno">  322</span>&#160;            <span class="keyword">const</span> shared_ptr&lt;Y&gt;&amp; r</div><div class="line"><a name="l00323"></a><span class="lineno">  323</span>&#160;        )</div><div class="line"><a name="l00324"></a><span class="lineno">  324</span>&#160;        {</div><div class="line"><a name="l00325"></a><span class="lineno">  325</span>&#160;            shared_ptr(r).swap(*<span class="keyword">this</span>);</div><div class="line"><a name="l00326"></a><span class="lineno">  326</span>&#160;            <span class="keywordflow">return</span> *<span class="keyword">this</span>;</div><div class="line"><a name="l00327"></a><span class="lineno">  327</span>&#160;        }</div><div class="line"><a name="l00328"></a><span class="lineno">  328</span>&#160; </div><div class="line"><a name="l00329"></a><span class="lineno">  329</span>&#160;        <span class="keyword">template</span>&lt;<span class="keyword">typename</span> Y&gt; </div><div class="line"><a name="l00330"></a><span class="lineno">  330</span>&#160;        shared_ptr&amp; operator= (</div><div class="line"><a name="l00331"></a><span class="lineno">  331</span>&#160;            std::auto_ptr&lt;Y&gt;&amp; r</div><div class="line"><a name="l00332"></a><span class="lineno">  332</span>&#160;        )</div><div class="line"><a name="l00333"></a><span class="lineno">  333</span>&#160;        {</div><div class="line"><a name="l00334"></a><span class="lineno">  334</span>&#160;            DLIB_ASSERT(r.get() != 0,</div><div class="line"><a name="l00335"></a><span class="lineno">  335</span>&#160;                <span class="stringliteral">&quot;\tshared_ptr::operator=(auto_ptr r)&quot;</span></div><div class="line"><a name="l00336"></a><span class="lineno">  336</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\tr.get() can&#39;t be null&quot;</span></div><div class="line"><a name="l00337"></a><span class="lineno">  337</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\tthis: &quot;</span> &lt;&lt; this</div><div class="line"><a name="l00338"></a><span class="lineno">  338</span>&#160;                );</div><div class="line"><a name="l00339"></a><span class="lineno">  339</span>&#160; </div><div class="line"><a name="l00340"></a><span class="lineno">  340</span>&#160;            reset();</div><div class="line"><a name="l00341"></a><span class="lineno">  341</span>&#160;            shared_node = <span class="keyword">new</span> shared_ptr_node;</div><div class="line"><a name="l00342"></a><span class="lineno">  342</span>&#160;            shared_node-&gt;del = <span class="keyword">new</span> default_deleter;</div><div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160;            data = r.release();</div><div class="line"><a name="l00344"></a><span class="lineno">  344</span>&#160;            <span class="keywordflow">return</span> *<span class="keyword">this</span>;</div><div class="line"><a name="l00345"></a><span class="lineno">  345</span>&#160;        }</div><div class="line"><a name="l00346"></a><span class="lineno">  346</span>&#160; </div><div class="line"><a name="l00347"></a><span class="lineno">  347</span>&#160;        <span class="keywordtype">void</span> reset()</div><div class="line"><a name="l00348"></a><span class="lineno">  348</span>&#160;        {</div><div class="line"><a name="l00349"></a><span class="lineno">  349</span>&#160;            shared_ptr().swap(*<span class="keyword">this</span>);</div><div class="line"><a name="l00350"></a><span class="lineno">  350</span>&#160;        }</div><div class="line"><a name="l00351"></a><span class="lineno">  351</span>&#160; </div><div class="line"><a name="l00352"></a><span class="lineno">  352</span>&#160;        <span class="keyword">template</span>&lt;<span class="keyword">typename</span> Y&gt; </div><div class="line"><a name="l00353"></a><span class="lineno">  353</span>&#160;        <span class="keywordtype">void</span> reset(Y* p)</div><div class="line"><a name="l00354"></a><span class="lineno">  354</span>&#160;        {</div><div class="line"><a name="l00355"></a><span class="lineno">  355</span>&#160;            DLIB_ASSERT(p != 0,</div><div class="line"><a name="l00356"></a><span class="lineno">  356</span>&#160;                <span class="stringliteral">&quot;\tshared_ptr::reset(p)&quot;</span></div><div class="line"><a name="l00357"></a><span class="lineno">  357</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\tp can&#39;t be null&quot;</span></div><div class="line"><a name="l00358"></a><span class="lineno">  358</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\tthis: &quot;</span> &lt;&lt; <span class="keyword">this</span></div><div class="line"><a name="l00359"></a><span class="lineno">  359</span>&#160;                );</div><div class="line"><a name="l00360"></a><span class="lineno">  360</span>&#160; </div><div class="line"><a name="l00361"></a><span class="lineno">  361</span>&#160;            shared_ptr(p).swap(*<span class="keyword">this</span>);</div><div class="line"><a name="l00362"></a><span class="lineno">  362</span>&#160;        }</div><div class="line"><a name="l00363"></a><span class="lineno">  363</span>&#160; </div><div class="line"><a name="l00364"></a><span class="lineno">  364</span>&#160;        <span class="keyword">template</span>&lt;<span class="keyword">typename</span> Y, <span class="keyword">typename</span> D&gt; </div><div class="line"><a name="l00365"></a><span class="lineno">  365</span>&#160;        <span class="keywordtype">void</span> reset(</div><div class="line"><a name="l00366"></a><span class="lineno">  366</span>&#160;            Y* p, </div><div class="line"><a name="l00367"></a><span class="lineno">  367</span>&#160;            <span class="keyword">const</span> D&amp; d</div><div class="line"><a name="l00368"></a><span class="lineno">  368</span>&#160;        )</div><div class="line"><a name="l00369"></a><span class="lineno">  369</span>&#160;        {</div><div class="line"><a name="l00370"></a><span class="lineno">  370</span>&#160;            DLIB_ASSERT(p != 0,</div><div class="line"><a name="l00371"></a><span class="lineno">  371</span>&#160;                <span class="stringliteral">&quot;\tshared_ptr::reset(p,d)&quot;</span></div><div class="line"><a name="l00372"></a><span class="lineno">  372</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\tp can&#39;t be null&quot;</span></div><div class="line"><a name="l00373"></a><span class="lineno">  373</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\tthis: &quot;</span> &lt;&lt; <span class="keyword">this</span></div><div class="line"><a name="l00374"></a><span class="lineno">  374</span>&#160;                );</div><div class="line"><a name="l00375"></a><span class="lineno">  375</span>&#160; </div><div class="line"><a name="l00376"></a><span class="lineno">  376</span>&#160;            shared_ptr(p,d).swap(*<span class="keyword">this</span>);</div><div class="line"><a name="l00377"></a><span class="lineno">  377</span>&#160;        }</div><div class="line"><a name="l00378"></a><span class="lineno">  378</span>&#160; </div><div class="line"><a name="l00379"></a><span class="lineno">  379</span>&#160;        T&amp; operator*(</div><div class="line"><a name="l00380"></a><span class="lineno">  380</span>&#160;        )<span class="keyword"> const </span></div><div class="line"><a name="l00381"></a><span class="lineno">  381</span>&#160;<span class="keyword">        </span>{ </div><div class="line"><a name="l00382"></a><span class="lineno">  382</span>&#160;            DLIB_ASSERT(get() != 0,</div><div class="line"><a name="l00383"></a><span class="lineno">  383</span>&#160;                <span class="stringliteral">&quot;\tshared_ptr::operator*()&quot;</span></div><div class="line"><a name="l00384"></a><span class="lineno">  384</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\tget() can&#39;t be null if you are going to dereference it&quot;</span></div><div class="line"><a name="l00385"></a><span class="lineno">  385</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\tthis: &quot;</span> &lt;&lt; <span class="keyword">this</span></div><div class="line"><a name="l00386"></a><span class="lineno">  386</span>&#160;                );</div><div class="line"><a name="l00387"></a><span class="lineno">  387</span>&#160; </div><div class="line"><a name="l00388"></a><span class="lineno">  388</span>&#160;            <span class="keywordflow">return</span> *data; </div><div class="line"><a name="l00389"></a><span class="lineno">  389</span>&#160;        } </div><div class="line"><a name="l00390"></a><span class="lineno">  390</span>&#160; </div><div class="line"><a name="l00391"></a><span class="lineno">  391</span>&#160;        T* operator-&gt;(</div><div class="line"><a name="l00392"></a><span class="lineno">  392</span>&#160;        )<span class="keyword"> const </span></div><div class="line"><a name="l00393"></a><span class="lineno">  393</span>&#160;<span class="keyword">        </span>{ </div><div class="line"><a name="l00394"></a><span class="lineno">  394</span>&#160;            DLIB_ASSERT(get() != 0,</div><div class="line"><a name="l00395"></a><span class="lineno">  395</span>&#160;                <span class="stringliteral">&quot;\tshared_ptr::operator-&gt;()&quot;</span></div><div class="line"><a name="l00396"></a><span class="lineno">  396</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\tget() can&#39;t be null&quot;</span></div><div class="line"><a name="l00397"></a><span class="lineno">  397</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\tthis: &quot;</span> &lt;&lt; <span class="keyword">this</span></div><div class="line"><a name="l00398"></a><span class="lineno">  398</span>&#160;                );</div><div class="line"><a name="l00399"></a><span class="lineno">  399</span>&#160; </div><div class="line"><a name="l00400"></a><span class="lineno">  400</span>&#160;            <span class="keywordflow">return</span> data; </div><div class="line"><a name="l00401"></a><span class="lineno">  401</span>&#160;        } </div><div class="line"><a name="l00402"></a><span class="lineno">  402</span>&#160;        </div><div class="line"><a name="l00403"></a><span class="lineno">  403</span>&#160;        T* get()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> data; } </div><div class="line"><a name="l00404"></a><span class="lineno">  404</span>&#160; </div><div class="line"><a name="l00405"></a><span class="lineno">  405</span>&#160;        <span class="keywordtype">bool</span> unique()<span class="keyword"> const </span></div><div class="line"><a name="l00406"></a><span class="lineno">  406</span>&#160;<span class="keyword">        </span>{  </div><div class="line"><a name="l00407"></a><span class="lineno">  407</span>&#160;            <span class="keywordflow">return</span> use_count() == 1;</div><div class="line"><a name="l00408"></a><span class="lineno">  408</span>&#160;        }</div><div class="line"><a name="l00409"></a><span class="lineno">  409</span>&#160; </div><div class="line"><a name="l00410"></a><span class="lineno">  410</span>&#160;        <span class="keywordtype">long</span> use_count()<span class="keyword"> const</span></div><div class="line"><a name="l00411"></a><span class="lineno">  411</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00412"></a><span class="lineno">  412</span>&#160;            <span class="keywordflow">if</span> (shared_node != 0) </div><div class="line"><a name="l00413"></a><span class="lineno">  413</span>&#160;                <span class="keywordflow">return</span> shared_node-&gt;ref_count;</div><div class="line"><a name="l00414"></a><span class="lineno">  414</span>&#160;            <span class="keywordflow">else</span></div><div class="line"><a name="l00415"></a><span class="lineno">  415</span>&#160;                <span class="keywordflow">return</span> 0;</div><div class="line"><a name="l00416"></a><span class="lineno">  416</span>&#160;        }</div><div class="line"><a name="l00417"></a><span class="lineno">  417</span>&#160; </div><div class="line"><a name="l00418"></a><span class="lineno">  418</span>&#160;        <span class="keyword">operator</span> bool(</div><div class="line"><a name="l00419"></a><span class="lineno">  419</span>&#160;        )<span class="keyword"> const </span>{ <span class="keywordflow">return</span> get() != 0; }  </div><div class="line"><a name="l00420"></a><span class="lineno">  420</span>&#160; </div><div class="line"><a name="l00421"></a><span class="lineno">  421</span>&#160;        <span class="keywordtype">void</span> swap(shared_ptr&amp; b)</div><div class="line"><a name="l00422"></a><span class="lineno">  422</span>&#160;        {</div><div class="line"><a name="l00423"></a><span class="lineno">  423</span>&#160;            std::swap(data, b.data);</div><div class="line"><a name="l00424"></a><span class="lineno">  424</span>&#160;            std::swap(shared_node, b.shared_node);</div><div class="line"><a name="l00425"></a><span class="lineno">  425</span>&#160;        }</div><div class="line"><a name="l00426"></a><span class="lineno">  426</span>&#160; </div><div class="line"><a name="l00427"></a><span class="lineno">  427</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> D&gt;</div><div class="line"><a name="l00428"></a><span class="lineno">  428</span>&#160;        D* _get_deleter(</div><div class="line"><a name="l00429"></a><span class="lineno">  429</span>&#160;        )<span class="keyword"> const</span></div><div class="line"><a name="l00430"></a><span class="lineno">  430</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00431"></a><span class="lineno">  431</span>&#160;            <span class="keywordflow">if</span> (shared_node &amp;&amp; shared_node-&gt;del)</div><div class="line"><a name="l00432"></a><span class="lineno">  432</span>&#160;                <span class="keywordflow">return</span> static_cast&lt;D*&gt;(shared_node-&gt;del-&gt;get_deleter_void(<span class="keyword">typeid</span>(D)));</div><div class="line"><a name="l00433"></a><span class="lineno">  433</span>&#160;            <span class="keywordflow">else</span></div><div class="line"><a name="l00434"></a><span class="lineno">  434</span>&#160;                <span class="keywordflow">return</span> 0;</div><div class="line"><a name="l00435"></a><span class="lineno">  435</span>&#160;        }</div><div class="line"><a name="l00436"></a><span class="lineno">  436</span>&#160; </div><div class="line"><a name="l00437"></a><span class="lineno">  437</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Y&gt;</div><div class="line"><a name="l00438"></a><span class="lineno">  438</span>&#160;        <span class="keywordtype">bool</span> _private_less (</div><div class="line"><a name="l00439"></a><span class="lineno">  439</span>&#160;            <span class="keyword">const</span> shared_ptr&lt;Y&gt;&amp; rhs</div><div class="line"><a name="l00440"></a><span class="lineno">  440</span>&#160;        )<span class="keyword"> const</span></div><div class="line"><a name="l00441"></a><span class="lineno">  441</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00442"></a><span class="lineno">  442</span>&#160;            <span class="keywordflow">return</span> shared_node &lt; rhs.shared_node;</div><div class="line"><a name="l00443"></a><span class="lineno">  443</span>&#160;        }</div><div class="line"><a name="l00444"></a><span class="lineno">  444</span>&#160; </div><div class="line"><a name="l00445"></a><span class="lineno">  445</span>&#160;    <span class="keyword">private</span>:</div><div class="line"><a name="l00446"></a><span class="lineno">  446</span>&#160; </div><div class="line"><a name="l00447"></a><span class="lineno">  447</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Y&gt; <span class="keyword">friend</span> <span class="keyword">class </span>shared_ptr;</div><div class="line"><a name="l00448"></a><span class="lineno">  448</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Y&gt; <span class="keyword">friend</span> <span class="keyword">class </span>weak_ptr;</div><div class="line"><a name="l00449"></a><span class="lineno">  449</span>&#160; </div><div class="line"><a name="l00450"></a><span class="lineno">  450</span>&#160;        T* data;</div><div class="line"><a name="l00451"></a><span class="lineno">  451</span>&#160;        shared_ptr_node* shared_node;</div><div class="line"><a name="l00452"></a><span class="lineno">  452</span>&#160;    };</div><div class="line"><a name="l00453"></a><span class="lineno">  453</span>&#160; </div><div class="line"><a name="l00454"></a><span class="lineno">  454</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00455"></a><span class="lineno">  455</span>&#160; </div><div class="line"><a name="l00456"></a><span class="lineno">  456</span>&#160;    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> U&gt;</div><div class="line"><a name="l00457"></a><span class="lineno">  457</span>&#160;    <span class="keywordtype">bool</span> operator== (</div><div class="line"><a name="l00458"></a><span class="lineno">  458</span>&#160;        <span class="keyword">const</span> shared_ptr&lt;T&gt;&amp; a, </div><div class="line"><a name="l00459"></a><span class="lineno">  459</span>&#160;        <span class="keyword">const</span> shared_ptr&lt;U&gt;&amp; b</div><div class="line"><a name="l00460"></a><span class="lineno">  460</span>&#160;    ) { <span class="keywordflow">return</span> a.get() == b.get(); }</div><div class="line"><a name="l00461"></a><span class="lineno">  461</span>&#160; </div><div class="line"><a name="l00462"></a><span class="lineno">  462</span>&#160;    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> U&gt;</div><div class="line"><a name="l00463"></a><span class="lineno">  463</span>&#160;    <span class="keywordtype">bool</span> operator!= (</div><div class="line"><a name="l00464"></a><span class="lineno">  464</span>&#160;        <span class="keyword">const</span> shared_ptr&lt;T&gt;&amp; a, </div><div class="line"><a name="l00465"></a><span class="lineno">  465</span>&#160;        <span class="keyword">const</span> shared_ptr&lt;U&gt;&amp; b</div><div class="line"><a name="l00466"></a><span class="lineno">  466</span>&#160;    ) { <span class="keywordflow">return</span> a.get() != b.get(); }</div><div class="line"><a name="l00467"></a><span class="lineno">  467</span>&#160; </div><div class="line"><a name="l00468"></a><span class="lineno">  468</span>&#160;    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> U&gt;</div><div class="line"><a name="l00469"></a><span class="lineno">  469</span>&#160;    <span class="keywordtype">bool</span> operator&lt; (</div><div class="line"><a name="l00470"></a><span class="lineno">  470</span>&#160;        <span class="keyword">const</span> shared_ptr&lt;T&gt;&amp; a, </div><div class="line"><a name="l00471"></a><span class="lineno">  471</span>&#160;        <span class="keyword">const</span> shared_ptr&lt;U&gt;&amp; b</div><div class="line"><a name="l00472"></a><span class="lineno">  472</span>&#160;    )</div><div class="line"><a name="l00473"></a><span class="lineno">  473</span>&#160;    {</div><div class="line"><a name="l00474"></a><span class="lineno">  474</span>&#160;        <span class="keywordflow">return</span> a._private_less(b);</div><div class="line"><a name="l00475"></a><span class="lineno">  475</span>&#160;    }</div><div class="line"><a name="l00476"></a><span class="lineno">  476</span>&#160; </div><div class="line"><a name="l00477"></a><span class="lineno">  477</span>&#160;    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt; </div><div class="line"><a name="l00478"></a><span class="lineno">  478</span>&#160;    <span class="keywordtype">void</span> swap(</div><div class="line"><a name="l00479"></a><span class="lineno">  479</span>&#160;        shared_ptr&lt;T&gt;&amp; a, </div><div class="line"><a name="l00480"></a><span class="lineno">  480</span>&#160;        shared_ptr&lt;T&gt;&amp; b</div><div class="line"><a name="l00481"></a><span class="lineno">  481</span>&#160;    ) { a.swap(b); }</div><div class="line"><a name="l00482"></a><span class="lineno">  482</span>&#160; </div><div class="line"><a name="l00483"></a><span class="lineno">  483</span>&#160;    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> U&gt;</div><div class="line"><a name="l00484"></a><span class="lineno">  484</span>&#160;    shared_ptr&lt;T&gt; static_pointer_cast(</div><div class="line"><a name="l00485"></a><span class="lineno">  485</span>&#160;        <span class="keyword">const</span> shared_ptr&lt;U&gt;&amp; r</div><div class="line"><a name="l00486"></a><span class="lineno">  486</span>&#160;    )</div><div class="line"><a name="l00487"></a><span class="lineno">  487</span>&#160;    {</div><div class="line"><a name="l00488"></a><span class="lineno">  488</span>&#160;        <span class="keywordflow">return</span> shared_ptr&lt;T&gt;(r, shared_ptr_static_cast());</div><div class="line"><a name="l00489"></a><span class="lineno">  489</span>&#160;    }</div><div class="line"><a name="l00490"></a><span class="lineno">  490</span>&#160; </div><div class="line"><a name="l00491"></a><span class="lineno">  491</span>&#160;    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> U&gt;</div><div class="line"><a name="l00492"></a><span class="lineno">  492</span>&#160;    shared_ptr&lt;T&gt; const_pointer_cast(</div><div class="line"><a name="l00493"></a><span class="lineno">  493</span>&#160;        shared_ptr&lt;U&gt; <span class="keyword">const</span> &amp; r</div><div class="line"><a name="l00494"></a><span class="lineno">  494</span>&#160;    )</div><div class="line"><a name="l00495"></a><span class="lineno">  495</span>&#160;    {</div><div class="line"><a name="l00496"></a><span class="lineno">  496</span>&#160;        <span class="keywordflow">return</span> shared_ptr&lt;T&gt;(r, shared_ptr_const_cast());</div><div class="line"><a name="l00497"></a><span class="lineno">  497</span>&#160;    }</div><div class="line"><a name="l00498"></a><span class="lineno">  498</span>&#160; </div><div class="line"><a name="l00499"></a><span class="lineno">  499</span>&#160;    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> U&gt;</div><div class="line"><a name="l00500"></a><span class="lineno">  500</span>&#160;    shared_ptr&lt;T&gt; dynamic_pointer_cast(</div><div class="line"><a name="l00501"></a><span class="lineno">  501</span>&#160;        <span class="keyword">const</span> shared_ptr&lt;U&gt;&amp; r</div><div class="line"><a name="l00502"></a><span class="lineno">  502</span>&#160;    )</div><div class="line"><a name="l00503"></a><span class="lineno">  503</span>&#160;    {</div><div class="line"><a name="l00504"></a><span class="lineno">  504</span>&#160;        <span class="keywordflow">return</span> shared_ptr&lt;T&gt;(r, shared_ptr_dynamic_cast());</div><div class="line"><a name="l00505"></a><span class="lineno">  505</span>&#160;    }</div><div class="line"><a name="l00506"></a><span class="lineno">  506</span>&#160; </div><div class="line"><a name="l00507"></a><span class="lineno">  507</span>&#160;    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> E, <span class="keyword">typename</span> T, <span class="keyword">typename</span> Y&gt;</div><div class="line"><a name="l00508"></a><span class="lineno">  508</span>&#160;    std::basic_ostream&lt;E, T&gt; &amp; operator&lt;&lt; (std::basic_ostream&lt;E, T&gt; &amp; os, shared_ptr&lt;Y&gt; <span class="keyword">const</span> &amp; p)</div><div class="line"><a name="l00509"></a><span class="lineno">  509</span>&#160;    {</div><div class="line"><a name="l00510"></a><span class="lineno">  510</span>&#160;        os &lt;&lt; p.get();</div><div class="line"><a name="l00511"></a><span class="lineno">  511</span>&#160;        <span class="keywordflow">return</span> os;</div><div class="line"><a name="l00512"></a><span class="lineno">  512</span>&#160;    }</div><div class="line"><a name="l00513"></a><span class="lineno">  513</span>&#160; </div><div class="line"><a name="l00514"></a><span class="lineno">  514</span>&#160;    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> D, <span class="keyword">typename</span> T&gt;</div><div class="line"><a name="l00515"></a><span class="lineno">  515</span>&#160;    D* get_deleter(<span class="keyword">const</span> shared_ptr&lt;T&gt;&amp; p)</div><div class="line"><a name="l00516"></a><span class="lineno">  516</span>&#160;    {</div><div class="line"><a name="l00517"></a><span class="lineno">  517</span>&#160;        <span class="keywordflow">return</span> p.template _get_deleter&lt;D&gt;();</div><div class="line"><a name="l00518"></a><span class="lineno">  518</span>&#160;    }</div><div class="line"><a name="l00519"></a><span class="lineno">  519</span>&#160; </div><div class="line"><a name="l00520"></a><span class="lineno">  520</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00521"></a><span class="lineno">  521</span>&#160; </div><div class="line"><a name="l00522"></a><span class="lineno">  522</span>&#160;}</div><div class="line"><a name="l00523"></a><span class="lineno">  523</span>&#160; </div><div class="line"><a name="l00524"></a><span class="lineno">  524</span>&#160;<span class="preprocessor">#endif // DLIB_SHARED_PTr_</span></div><div class="line"><a name="l00525"></a><span class="lineno">  525</span>&#160; </div></div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="astructdlib_1_1shared__ptr__node_html"><div class="ttname"><a href="structdlib_1_1shared__ptr__node.html">dlib::shared_ptr_node</a></div><div class="ttdef"><b>Definition:</b> shared_ptr.h:58</div></div>
<div class="ttc" id="astructdlib_1_1default__deleter_html"><div class="ttname"><a href="structdlib_1_1default__deleter.html">dlib::default_deleter</a></div><div class="ttdef"><b>Definition:</b> scoped_ptr.h:17</div></div>
<div class="ttc" id="astructdlib_1_1shared__ptr__dynamic__cast_html"><div class="ttname"><a href="structdlib_1_1shared__ptr__dynamic__cast.html">dlib::shared_ptr_dynamic_cast</a></div><div class="ttdef"><b>Definition:</b> shared_ptr.h:74</div></div>
<div class="ttc" id="astructdlib_1_1shared__ptr_1_1deleter__template_html"><div class="ttname"><a href="structdlib_1_1shared__ptr_1_1deleter__template.html">dlib::shared_ptr::deleter_template</a></div><div class="ttdef"><b>Definition:</b> shared_ptr.h:104</div></div>
<div class="ttc" id="astructdlib_1_1shared__ptr__static__cast_html"><div class="ttname"><a href="structdlib_1_1shared__ptr__static__cast.html">dlib::shared_ptr_static_cast</a></div><div class="ttdef"><b>Definition:</b> shared_ptr.h:72</div></div>
<div class="ttc" id="aclassdlib_1_1bad__weak__ptr_html"><div class="ttname"><a href="classdlib_1_1bad__weak__ptr.html">dlib::bad_weak_ptr</a></div><div class="ttdef"><b>Definition:</b> shared_ptr.h:19</div></div>
<div class="ttc" id="aclassdlib_1_1shared__ptr_html"><div class="ttname"><a href="classdlib_1_1shared__ptr.html">dlib::shared_ptr</a></div><div class="ttdef"><b>Definition:</b> shared_ptr.h:79</div></div>
<div class="ttc" id="aclassdlib_1_1weak__ptr_html"><div class="ttname"><a href="classdlib_1_1weak__ptr.html">dlib::weak_ptr</a></div><div class="ttdef"><b>Definition:</b> shared_ptr.h:23</div></div>
<div class="ttc" id="astructdlib_1_1shared__ptr__const__cast_html"><div class="ttname"><a href="structdlib_1_1shared__ptr__const__cast.html">dlib::shared_ptr_const_cast</a></div><div class="ttdef"><b>Definition:</b> shared_ptr.h:73</div></div>
<div class="ttc" id="astructdlib_1_1shared__ptr__deleter_html"><div class="ttname"><a href="structdlib_1_1shared__ptr__deleter.html">dlib::shared_ptr_deleter</a></div><div class="ttdef"><b>Definition:</b> shared_ptr.h:27</div></div>
<div class="ttc" id="astructdlib_1_1shared__ptr_1_1default__deleter_html"><div class="ttname"><a href="structdlib_1_1shared__ptr_1_1default__deleter.html">dlib::shared_ptr::default_deleter</a></div><div class="ttdef"><b>Definition:</b> shared_ptr.h:119</div></div>
<div class="ttc" id="astructdlib_1_1weak__ptr__node_html"><div class="ttname"><a href="structdlib_1_1weak__ptr__node.html">dlib::weak_ptr_node</a></div><div class="ttdef"><b>Definition:</b> shared_ptr.h:43</div></div>
<div class="ttc" id="anamespacedlib_html"><div class="ttname"><a href="namespacedlib.html">dlib</a></div><div class="ttdef"><b>Definition:</b> algs.h:119</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
